/*
    writerom.S : write  to EEPROM
*/
;
#include "h83048addr.h"
;
#define AAAA #40
#define BBBB #12
#define GGGG #15
#define WDTVAL #0xA57F
;;; 
;;; 
;;; writebyte : write 1 byte to EEPROM
;;; int writebyte(int addr,unsigned char* value)
;;; 
;;; r2h = EBR1
;;; er5 = address
;;; er1 = length
	.h8300h
	.section .text
	.align 1
	.global _main
_main:
; SCI initialization
	bset	#4,@SCR1:8
	bset	#5,@SCR1:8
	mov.w	#0xff00,r0
	mov.b	r0h,@PBDDR

; get length
	sub.l	er1,er1
.LL1:	btst	#6,@SSR1:8
	beq	.LL1
	mov.b	@RDR1:8,r1l
	bclr	#6,@SSR1:8
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1

.LL2:	btst	#6,@SSR1:8
	beq	.LL2
	mov.b	@RDR1:8,r1l
	bclr	#6,@SSR1:8
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1

.LL3:	btst	#6,@SSR1:8
	beq	.LL3
	mov.b	@RDR1:8,r1l
	bclr	#6,@SSR1:8
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1
	shll	er1

.LL4:	btst	#6,@SSR1:8
	beq	.LL4
	mov.b	@RDR1:8,r1l
	bclr	#6,@SSR1:8

	sub.l	er5,er5

	sub.b	r0l,r0l
	mov.b	r0l,@FLMCR:8

	mov.b	#1,r2h

_BYTE1:
.LL5:	btst	#6,@SSR1:8
	beq	.LL5
	mov.b	@RDR1:8,r2l
	bclr	#6,@SSR1:8

	mov.w	#0001, r3 ; Program-verify fail count
	bset	#6,@FLMCR:8

	mov.w	GGGG, r0
.L0:	dec.w	#1, r0 ;
	bpl	.L0

	mov.b	r2h, @EBR1:8 ; Set EBR1
	mov.b	r2l, @er5 ; Dummy write

	mov.w	AAAA, r4 ; Set initial program loop counter value
PRGMS:	mov.w	WDTVAL, r0 ; Start watchdog timer
	mov.w	r0, @TCSR:16 ;
	bset	#0,@FLMCR:8

	mov.w	r4, r0 ; Set program loop counter
.L1:	dec.w	#1, r0 ; Program
	bpl	.L1

	bclr	#0,@FLMCR:8

	mov.w	#0xA500, r0 ;
	mov.w	r0, @TCSR:16 ; Stop watchdog timer

	bset	#2,@FLMCR:8

	mov.w	BBBB , r0 ; Set program-verify loop counter
.L2:	dec.w	#1, r0 ; Wait
	bpl	.L2

	mov.b	@er5,r0l
	cmp.b	r2l,r0l

	beq	PVOK ; Program-verify decision
PVNG:
	bclr	#2,@FLMCR:8

	cmp.b	#06, r3l ; Program-verify executed 6 times?
	beq	NGEND ; If program-verify executed 6 times, branch to NGEND
	inc.b	r3l ; Program-verify fail count + 1 @ R0L
	shll.w	r4 ; Double program loop counter value
	bra	PRGMS ; Program again
PVOK:
	bclr	#2,@FLMCR:8

	bclr	#0,@EBR1:8
	bclr	#6,@FLMCR:8


; send 1 byte of data
.L3:
	sub.b	r2l,r2l
	btst	#7,@SSR1:8
	beq	.L3
	mov.b	r2l,@TDR1:8
	bclr	#7,@SSR1:8

	inc.l	#1,er5
	mov.w	r5,r0	
	and.w	#0x3fff,r0
	bne	.L31
;;; increment EBR at LB boundary
	add	r2h,r2h
.L31:	cmp.l	er5,er1
	beq	_EXIT
	jmp	_BYTE1

NGEND:
	bclr	#0,@EBR1:8
	bclr	#6,@FLMCR:8
;DEBUG
	mov.b	@FLMCR:8,r0h
	mov.b	r0h,@PBDR:8

; send 1 byte of the data
.L4:	btst	#7,@SSR1:8
	beq	.L4
	mov.b	r0l,@TDR1:8
	bclr	#7,@SSR1:8

_EXIT:
; loop while few usec
	mov.w	#0x1000, r0 ; Set program loop counter
.L45:	dec.w	#1, r0 ; Program
	bpl	.L45
#if 0
; send bytes of the data
	sub.l	er5,er5

.L47:	mov.b	@er5,r2l
.L5:	btst	#7,@SSR1:8
	beq	.L5
	mov.b	r2l,@TDR1:8
	bclr	#7,@SSR1:8
	
	inc.l	#1,er5
	cmp.l	er5,er1
	bne	.L47
#endif
.L6:	
	jmp	@0x100:32
	bra	_EXIT	
	.end